算法002:复写零

力扣(LeetCode). - 备战技术面试?力扣提供海量技术面试资源,帮助你高效提升编程技能,轻松拿下世界 IT 名企 Dream Offer。https://leetcode.cn/problems/duplicate-zeros/

使用 双指针 来解题:

具体思路

如果是和001题一样的,使用双指针从前往后扫描,并且修改相关的值的话,会出现某些值被覆盖,不能完成题目要求。于是我们采用双指针从后往前覆写。

分为三步走:

1.让双指针从左往右扫描,让右指针遍历数组,左指针遇见非0的数就向右+1,遇见0的数就向右+2。这样做的目的是让两个指针能够刚好停在一个位置,这个位置的左边是保留下来的数字,这个位置的右边是舍弃掉的数字

2.处理特殊情况。如果在数组倒数第二个数,则会出现L指针超过数组的长度的情况

此时要处理这种特殊的情况,把R和L中间的元素变成0,并且让R和L都往前移动一个。此时再继续进行下一步。

3.从后往前覆写。当R位置不为0的时候,让R和L都向左移动就可以了。当R位置的值为0的时候,让L的位置也变成0,并且让R--,L-=2。因为在第一步已经规定了两个指针对应的位置,所以L一次性向左移动两个位置也不会出现位置错乱的情况。

代码:

java 复制代码
class Solution {
    public void duplicateZeros(int[] arr) {
        int left = -1;
        int right = 0;
        int n = arr.length;
        //1.先让left和right都到应该到的位置
        while(right < n){
            if(arr[right] == 0){
                left += 2;
            }else{
                left++;
            }
            if(left >= n-1){
                break;
            }
            right++;
        }
        //2.处理特殊情况
        if(left == n){
            arr[n-1] = 0;
            left -= 2;
            right--;
        }
        //3.从后往前覆写
        while(right >= 0){
            if(arr[right] != 0){
                arr[left--] = arr[right--];
            }else{
                arr[left--] = 0;
                arr[left--] = 0;       
                right--;
            }
        }
    }
}
相关推荐
索尔~古德曼4 分钟前
CF(1400-1400&1300-1500)错题集
算法
All for pursuit.1 小时前
【二分查找-2】34.在排序数组中查找元素的第一个和最后一个位置
数据结构·c++·算法·leetcode
泯泷1 小时前
为什么 AI 会"失忆"?——读懂 Agent 的记忆系统(一)
人工智能·算法·agent
需要8263 小时前
分布式 ID 生成:雪花算法、号段模式与时钟回拨
分布式·算法
垆边人似月.3 小时前
华为机考题:字符串分隔
算法·华为
CQU_JIAKE3 小时前
9.4【A】
算法
CQU_JIAKE3 小时前
9.13[A]
算法
懿路向前3 小时前
【唤醒实战笔记】2026-09-29 | 智能体提示词迭代史(v1 → v8)
linux·笔记·算法
@陈小鱼4 小时前
基于CNN-Transformer的无袖带血压估计
人工智能·深度学习·神经网络·算法·cnn·transformer·血压
黄金龙PLUS4 小时前
5个1280比特大状态置换算法的设计与分析
算法·网络安全·密码学·哈希算法·同态加密